#include <stdint.h>
#include "flash_2_hw.h"


sbit FLASH_2_HLD at LATC3_bit;
sbit FLASH_2_HLD_DIR at TRISC3_bit;
sbit FLASH_2_CS at LATC4_bit;
sbit FLASH_2_CS_DIR at TRISC4_bit;
sbit FLASH_2_WP at LATD1_bit;
sbit FLASH_2_WP_DIR at TRISD1_bit;

void main()
{

  uint8_t buffer[4]                   = {15,20,25,30};
  uint32_t count                      = 4;
  uint32_t address                    = 0x010000;
  uint8_t receive_buffer[4];
  char tmp[20];

  ANSELA = 0x00;
  ANSELB = 0x00;
  ANSELC = 0x00;
  ANSELD = 0x00;
  ANSELE = 0x00;
  ANSELG = 0x00;

  FLASH_2_HLD_DIR = 0;
  FLASH_2_WP_DIR = 0;
  FLASH_2_CS_DIR = 0;
  Delay_ms( 200 );

  PPS_Mapping( 104, _OUTPUT, _SDO3 );
  PPS_Mapping( 98, _INPUT, _SDI3 );
  PPS_Mapping( 79, _OUTPUT, _SCK3OUT );
  SPI3_Init_Advanced( _SPI_MASTER, _SPI_8_BIT,
                        _SPI_PRESCALE_SEC_4, _SPI_PRESCALE_PRI_16,
                        _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_END,
                        _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE );
  Delay_ms( 200 );

  PPS_Mapping( 100, _INPUT, _U1RX );
  PPS_Mapping( 101, _OUTPUT, _U1TX );

  UART1_Init( 9600 );
  Delay_ms(200);
   
  UART1_Write_Text( "UART Initialized\r\n" );

  flash_2_init();
  Delay_ms(300);
  flash_2_global_block_unlock();
  Delay_ms(400);
  flash_2_chip_erase();
  Delay_ms(300);
  flash_2_write( address, buffer, count );
  flash_2_read( address, receive_buffer, count );

UART1_Write_Text( "Initial Values: " );
    while( count-- )
    {
       ByteToStr( buffer[count], tmp );
       UART1_Write_Text( tmp );
    }
    UART1_Write_Text( "\r\n" );
    count = 4;

    UART1_Write_Text( "Received Values: " );
    while( count -- )
    {
       ByteToStr( receive_buffer[count], tmp );
       UART1_Write_Text( tmp );
    }
    UART1_Write_Text( "\r\n" );

    return;


}