> ![MikroE](http://www.mikroe.com/img/designs/beta/logo_small.png)
> #Flash 2 Click#
> ##By [MikroElektronika](http://www.mikroe.com)
---

## Installation
Use the package manager to install the library for your architecture.

###Example on dsPIC
```
#include <stdint.h>

sbit FLASH_2_HLD at LATC3_bit;
sbit FLASH_2_HLD_DIR at TRISC3_bit;
sbit FLASH_2_CS at LATC4_bit;
sbit FLASH_2_CS_DIR at TRISC4_bit;
sbit FLASH_2_WP at LATD1_bit;
sbit FLASH_2_WP_DIR at TRISD1_bit;

void setup()
{
  ANSELA = 0x00;
  ANSELB = 0x00;
  ANSELC = 0x00;
  ANSELD = 0x00;
  ANSELE = 0x00;
  ANSELG = 0x00;

  FLASH_2_HLD_DIR = 0;
  FLASH_2_WP_DIR = 0;
  FLASH_2_CS_DIR = 0;
  Delay_ms( 200 );

  PPS_Mapping( 104, _OUTPUT, _SDO3 );
  PPS_Mapping( 98, _INPUT, _SDI3 );
  PPS_Mapping( 79, _OUTPUT, _SCK3OUT );
  SPI3_Init_Advanced( _SPI_MASTER, _SPI_8_BIT,
                        _SPI_PRESCALE_SEC_4, _SPI_PRESCALE_PRI_16,
                        _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_END,
                        _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE );
  Delay_ms( 200 );

  PPS_Mapping( 100, _INPUT, _U1RX );
  PPS_Mapping( 101, _OUTPUT, _U1TX );

}

```

```
// Main function

int main(void)
{
	setup();

    flash_2_init();
    Delay_ms(300);
    
    while(1)
    {}

}
```

